Loading...
Searching...
No Matches
or/unglq: Generate Q from LQ factorization
Dense LA » Orthogonal/unitary factorizations » LQ factorization

## Functions

magma_int_t | magma_cunglq (magma_int_t m, magma_int_t n, magma_int_t k, magmaFloatComplex *A, magma_int_t lda, magmaFloatComplex *tau, magmaFloatComplex *work, magma_int_t lwork, magma_int_t *info)
magma_int_t | magma_dorglq (magma_int_t m, magma_int_t n, magma_int_t k, double *A, magma_int_t lda, double *tau, double *work, magma_int_t lwork, magma_int_t *info)
magma_int_t | magma_sorglq (magma_int_t m, magma_int_t n, magma_int_t k, float *A, magma_int_t lda, float *tau, float *work, magma_int_t lwork, magma_int_t *info)
magma_int_t | magma_zunglq (magma_int_t m, magma_int_t n, magma_int_t k, magmaDoubleComplex *A, magma_int_t lda, magmaDoubleComplex *tau, magmaDoubleComplex *work, magma_int_t lwork, magma_int_t *info)

## Detailed Description

## Function Documentation

## magma_cunglq()

magma_int_t magma_cunglq | ( | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magmaFloatComplex * | tau,
|  | magmaFloatComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

## Purpose:

CUNGLQ generates an M-by-N complex matrix Q with orthonormal rows, which is defined as the first M rows of a product of K elementary reflectors of order N

    Q  =  H(k)**H . . . H(2)**H H(1)**H

as returned by CGELQF.

## Arguments:

Parameters

  [in] | m | INTEGER The number of rows of the matrix Q. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix Q. N >= M.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. M >= K >= 0.
  [in,out] | A | COMPLEX array, dimension (LDA,N) On entry, the i-th row must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by CGELQF in the first k rows of its array argument A. On exit, the M-by-N matrix Q.
  [in] | lda | INTEGER The first dimension of the array A. LDA >= max(1,M).
  [in] | tau | COMPLEX array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by CGELQF.
  [out] | work | COMPLEX array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
  [in] | lwork | INTEGER The dimension of the array WORK. LWORK >= M*NB, where NB is the optimal blocksize.

If LWORK = -1, a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

Parameters

  [out]

  info

  INTEGER
  - = 0: successful exit;
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_dorglq()

magma_int_t magma_dorglq | ( | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | double * | A,
|  | magma_int_t | lda,
|  | double * | tau,
|  | double * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

## Purpose:

DORGLQ generates an M-by-N real matrix Q with orthonormal rows, which is defined as the first M rows of a product of K elementary reflectors of order N

    Q  =  H(k)**H . . . H(2)**H H(1)**H

as returned by DGELQF.

## Arguments:

Parameters

  [in] | m | INTEGER The number of rows of the matrix Q. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix Q. N >= M.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. M >= K >= 0.
  [in,out] | A | DOUBLE PRECISION array, dimension (LDA,N) On entry, the i-th row must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by DGELQF in the first k rows of its array argument A. On exit, the M-by-N matrix Q.
  [in] | lda | INTEGER The first dimension of the array A. LDA >= max(1,M).
  [in] | tau | DOUBLE PRECISION array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by DGELQF.
  [out] | work | DOUBLE PRECISION array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
  [in] | lwork | INTEGER The dimension of the array WORK. LWORK >= M*NB, where NB is the optimal blocksize.

If LWORK = -1, a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

Parameters

  [out]

  info

  INTEGER
  - = 0: successful exit;
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_sorglq()

magma_int_t magma_sorglq | ( | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | float * | A,
|  | magma_int_t | lda,
|  | float * | tau,
|  | float * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

## Purpose:

SORGLQ generates an M-by-N real matrix Q with orthonormal rows, which is defined as the first M rows of a product of K elementary reflectors of order N

    Q  =  H(k)**H . . . H(2)**H H(1)**H

as returned by SGELQF.

## Arguments:

Parameters

  [in] | m | INTEGER The number of rows of the matrix Q. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix Q. N >= M.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. M >= K >= 0.
  [in,out] | A | REAL array, dimension (LDA,N) On entry, the i-th row must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by SGELQF in the first k rows of its array argument A. On exit, the M-by-N matrix Q.
  [in] | lda | INTEGER The first dimension of the array A. LDA >= max(1,M).
  [in] | tau | REAL array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by SGELQF.
  [out] | work | REAL array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
  [in] | lwork | INTEGER The dimension of the array WORK. LWORK >= M*NB, where NB is the optimal blocksize.

If LWORK = -1, a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

Parameters

  [out]

  info

  INTEGER
  - = 0: successful exit;
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_zunglq()

magma_int_t magma_zunglq | ( | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magmaDoubleComplex * | tau,
|  | magmaDoubleComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

## Purpose:

ZUNGLQ generates an M-by-N complex matrix Q with orthonormal rows, which is defined as the first M rows of a product of K elementary reflectors of order N

    Q  =  H(k)**H . . . H(2)**H H(1)**H

as returned by ZGELQF.

## Arguments:

Parameters

  [in] | m | INTEGER The number of rows of the matrix Q. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix Q. N >= M.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. M >= K >= 0.
  [in,out] | A | COMPLEX_16 array, dimension (LDA,N) On entry, the i-th row must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by ZGELQF in the first k rows of its array argument A. On exit, the M-by-N matrix Q.
  [in] | lda | INTEGER The first dimension of the array A. LDA >= max(1,M).
  [in] | tau | COMPLEX_16 array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by ZGELQF.
  [out] | work | COMPLEX_16 array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
  [in] | lwork | INTEGER The dimension of the array WORK. LWORK >= M*NB, where NB is the optimal blocksize.

If LWORK = -1, a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

Parameters

  [out]

  info

  INTEGER
  - = 0: successful exit;
  - < 0: if INFO = -i, the i-th argument had an illegal value